﻿----------------------------------------------------------------------------
----Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------

thirdPerson = {};
local modDescFile = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");
thirdPerson.title = getXMLString(modDescFile, "modDesc.title.en");
thirdPerson.author = getXMLString(modDescFile, "modDesc.author");
thirdPerson.version = getXMLString(modDescFile, "modDesc.version");
thirdPerson.inputsXML = getUserProfileAppPath().. "inputBinding.xml";
thirdPerson.cam = {};
thirdPerson.cam.node = "3|1";
thirdPerson.camWasTP = true;
thirdPerson.keyDown = false;
thirdPerson.btnDown = false;	
thirdPerson.isActive = true;
thirdPerson.doOnce = false;
delete(modDescFile);

addModEventListener(thirdPerson);

print("Load mod: "..thirdPerson.title.." : v"..thirdPerson.version.." by "..thirdPerson.author);

function thirdPerson:loadMap(savegame)
	Player.loadVisuals = Utils.prependedFunction(thirdPerson.loadVisuals, Player.loadVisuals);
	Player.update = Utils.prependedFunction(thirdPerson.playerUpdate, Player.update);
	--HandTool.update = Utils.prependedFunction(thirdPerson.checkTools, HandTool.update);
	thirdPerson:getCameraKey();
end;

function thirdPerson:loadVisuals(xmlFilename, playerStyle, linkNode, isRealPlayer, ikChains, getParentFunc, getParentFuncTarget, parentObj)
    self.customEnvironment, self.baseDirectory = Utils.getModNameAndBaseDirectory(xmlFilename);
    local xmlFile = loadXMLFile("TempXML", xmlFilename);
    if xmlFile == 0 then
        return false;
    end;
    local filename = getXMLString(xmlFile, "player.filename");
    self.filename = Utils.getFilename(filename, self.baseDirectory);
    local rootNode = g_i3DManager:loadSharedI3DFile(self.filename, nil, nil, true);

	self.playerCamera2 = I3DUtil.indexToObject(rootNode, thirdPerson.cam.node);
	--print( self.customEnvironment);
end;

function thirdPerson:playerUpdate(dt)

	if thirdPerson.isActive then		
		if self.isClient then
			if not thirdPerson.doOnce then -- doOnce
				if self.skeletonThirdPerson ~= nil and self.meshThirdPerson ~= nil then 
					if self.cameraNode ~= nil then						
						thirdPerson.doOnce = true;
						thirdPerson:initializeSettings(self);
						thirdPerson:initializeCamera(self);
						thirdPerson:initializeFlashLight(self);						
						thirdPerson:setVisibility(self, true);
					   
						self:updateAnimationParameters(dt);
						updateConditionalAnimation(self.animationInformation.player, dt);
							
					end; -----------------------------------------
				end;					
			end;
		-----Per Tic-----
			thirdPerson:updateAnimations(self, dt);
		------------------
		end;
	end;
	
	local currentCam = getCamera();
	if not Input.isKeyPressed(Input[thirdPerson.cameraKey]) and thirdPerson.keyDown then
		thirdPerson.keyDown = false;	
	elseif Input.isKeyPressed(Input[thirdPerson.cameraKey]) and not thirdPerson.keyDown then
		thirdPerson.keyDown = true;
		if currentCam == self.cameraNode then
			thirdPerson:setVisibility(self, true);
			setCamera(getChildAt(self.playerCamera2, 0));
			thirdPerson:initializeFlashLight(self);	
			thirdPerson.isActive = true;
			thirdPerson.camWasTP = true;
		else
			thirdPerson:setVisibility(self, false);
			setCamera(self.cameraNode);
			thirdPerson:resetFlashLight(self);
			thirdPerson.isActive = false;
			thirdPerson.camWasTP = false;
		end;
	end;

	if not Input.isMouseButtonPressed(Input.MOUSE_BUTTON_RIGHT) and thirdPerson.btnDown then
		thirdPerson.btnDown = false;	
		thirdPerson:mirrorCamera(self.playerCamera2);
	elseif Input.isMouseButtonPressed(Input.MOUSE_BUTTON_RIGHT) and not thirdPerson.btnDown then
		thirdPerson.btnDown = true;	
		thirdPerson:mirrorCamera(self.playerCamera2);
		--self.walkingIsLocked = not self.walkingIsLocked;
	end;
	
	if currentCam == self.cameraNode and getVisibility(self.meshThirdPerson) then		
		thirdPerson:setVisibility(self, false);
	elseif currentCam == getChildAt(self.playerCamera2, 0) and not getVisibility(self.meshThirdPerson) then		
		thirdPerson:setVisibility(self, true);
	end;

end;

function thirdPerson:updateAnimations(self, dt)	

	--[[if self.playerStateMachine:isActive("jump") then
		self.playerStateMachine:deactivateState("fall");
	end;]]	
	--if self.playerStateMachine:isActive("crouch") then
		--local x,y,z = getTranslation(self.playerCamera2);
		--thirdPerson.camY = y;
		--setTranslation(self.playerCamera2, x,crouchState.crouchCameraY,z);
	--end;

	if self:hasHandtoolEquipped() then
		IKUtil.updateIKChains(self.baseInformation.currentHandtool.targets);
        self:setIKDirty();
	end;

	if self.isCarryingObject ~= nil and self.isCarryingObject then --self.playerStateMachine:isAvailable("throw") then
		thirdPerson:setVisibility(self, false);
		setCamera(self.cameraNode);
		thirdPerson.isActive = false;
		thirdPerson.camWasTP = false;
		--renderText("advise player of camera change due to object");
	end;

	self:updatePlayerStates();
	self.playerStateMachine:update(dt);	
	self:updateActionEvents();			

	self:updateAnimationParameters(dt);
	updateConditionalAnimation(self.animationInformation.player, dt);

	self:updateWaterParms();
	self.baseInformation.isCrouched = self.playerStateMachine:isActive("crouch");
	
end;					

function thirdPerson:setVisibility(self, visible)	
	setVisibility(self.meshThirdPerson, visible);	
	self.visualInformation:setVisibility(visible);
	setVisibility(self.skeletonThirdPerson, visible);	
	setVisibility(self.animRootThirdPerson, visible);		
end;

function thirdPerson:initializeCamera(self)	
	link(self.cameraNode, self.playerCamera2);

	local _,y2,_ = getTranslation(self.cameraNode);
	local x,y,z = getTranslation(self.playerCamera2);
	setTranslation(self.playerCamera2, x,y-y2,z);
	local rx,ry,rz = getRotation(self.playerCamera2);
	setRotation(self.playerCamera2, rx,ry+math.rad(-180),rz);

	setCamera(getChildAt(self.playerCamera2, 0));
end;						

function thirdPerson:mirrorCamera(camera)
	local rx,ry,rz = getRotation(camera);
	if ry ~= 0.0 then
		ry = 0.0;
		setRotation(camera, rx,ry,rz);
	else
		setRotation(camera, rx,ry+math.rad(-180),rz);
	end;
	--g_gameSettings:setValue("invertYLook",not g_gameSettings:getValue("invertYLook"));
end;

function thirdPerson:initializeFlashLight(self)
	unlink(self.lightNode);
	link(self.skeletonThirdPerson, self.lightNode);
	local rx,ry,rz = getRotation(self.lightNode);
	setRotation(self.lightNode, rx,ry+math.rad(-180),rz);
	local x,y,z = getTranslation(self.lightNode);
	setTranslation(self.lightNode, x,y+1.2,z);
end;	

function thirdPerson:resetFlashLight(self)	
	unlink(self.lightNode);
	link(self.cameraNode, self.lightNode);
	local x,y,z = getTranslation(self.lightNode);
	setTranslation(self.lightNode, 0,0,0);
	setRotation(self.lightNode, 0,0,0);
end;

function thirdPerson:initializeSettings(self)

	self.baseInformation.isOnGround = true;
	self.baseInformation.isOnGroundPhysics = true;

	if self.skeletonThirdPerson ~= nil and getNumOfChildren(self.skeletonThirdPerson) > 0 then
		--
		local xmlFile = loadXMLFile("TempXML", self.xmlFilename);		
		self.particleSystemsInformation.swimNode   = createTransformGroup("swimFXNode");
		link(getRootNode(), self.particleSystemsInformation.swimNode);
		self.particleSystemsInformation.plungeNode = createTransformGroup("plungeFXNode");
		link(getRootNode(), self.particleSystemsInformation.plungeNode);
		key = "player.particleSystems";
		ParticleUtil.loadParticleSystem(xmlFile, self.particleSystemsInformation.systems.swim, key..".swim", self.particleSystemsInformation.swimNode, false, nil, self.baseDirectory);
		ParticleUtil.loadParticleSystem(xmlFile, self.particleSystemsInformation.systems.plunge, key..".plunge", self.particleSystemsInformation.plungeNode, false, nil, self.baseDirectory);
		--
		self.animationCharsetId = getAnimCharacterSet(getChildAt(self.skeletonThirdPerson, 0));	
		local animNode = g_animCache:getNode(AnimationCache.CHARACTER);
		cloneAnimCharacterSet(animNode, getParent(self.skeletonThirdPerson));
		local animCharsetId = getAnimCharacterSet(getChildAt(self.skeletonThirdPerson, 0));
		self.animationInformation.player = createConditionalAnimation();
		for key, parameter in pairs(self.animationInformation.parameters) do
			conditionalAnimationRegisterParameter(self.animationInformation.player, parameter.id, parameter.type, key);
		end;
		initConditionalAnimation(self.animationInformation.player, animCharsetId, self.xmlFilename, "player.conditionalAnimation");
		setConditionalAnimationSpecificParameterIds(self.animationInformation.player, self.animationInformation.parameters.absForwardVelocity.id, self.animationInformation.parameters.yawVelocity.id);
    end;
	
end;

function thirdPerson:getCameraKey()
	local xmlFile = loadXMLFile("inputBinding", thirdPerson.inputsXML)	
	local i = 0;
	while true do
		local objKey = string.format("inputBinding.actionBinding(%d)", i);
		local inputKey = getXMLString(xmlFile, objKey.."#action")
		if inputKey == nil then
			break;
		end;
		if inputKey == "CAMERA_SWITCH" then
			thirdPerson.cameraKey = getXMLString(xmlFile, objKey.. ".binding#input")
			break;
		end;
        i = i + 1;
	end;
end;

function thirdPerson:checkTools()    
	if thirdPerson.isActive then		
		thirdPerson:setVisibility(self.player, false);
		thirdPerson:resetFlashLight(self.player);
		thirdPerson.isActive = false;
		thirdPerson.camWasTP = false;
	end;
end;
---------------------------------------------------------------------------------------
Player.updateRotation = function(self, dt)
   if thirdPerson.isActive then
        local animDt = 60
        self.animUpdateTime = self.animUpdateTime + dt
        if self.animUpdateTime > animDt then
            --if self.isServer then
                local x, _, z = localDirectionToLocal(self.cameraNode, getParent(self.cameraNode), 0, 0, 1)
                local alpha = math.atan2(x, z)
                self.cameraRotY = alpha
            --end
            local x, y, z = getTranslation(self.graphicsRootNode)
            local dx, _, dz = x - self.lastAnimPosX, y - self.lastAnimPosY, z - self.lastAnimPosZ
            local dirX, dirZ = -math.sin(self.cameraRotY), -math.cos(self.cameraRotY)
            local movementDist = dx * dirX + dz * dirZ -- Note: |dir| = 1
            if (dx * dx + dz * dz) < 0.001 then
                self.targetGraphicsRotY = self.cameraRotY + math.rad(180.0)
            else
                if movementDist > -0.001 then
                    self.targetGraphicsRotY = math.atan2(dx, dz)
                else
                    self.targetGraphicsRotY = math.atan2(-dx, -dz)
                end
            end
            dirX, dirZ = -math.sin(self.targetGraphicsRotY), -math.cos(self.targetGraphicsRotY)
            movementDist = dx * dirX + dz * dirZ -- Note: |dir| = 1
            movementDist = self.walkDistance * 0.2 + movementDist * 0.8
            self.walkDistance = movementDist
            self.lastEstimatedForwardVelocity = -movementDist / (self.animUpdateTime * 0.001)
            self.lastAnimPosX = x
            self.lastAnimPosY = y
            self.lastAnimPosZ = z
            self.baseInformation.animDt = self.animUpdateTime
            self.animUpdateTime = 0
        end
        self.targetGraphicsRotY = MathUtil.normalizeRotationForShortestPath(self.targetGraphicsRotY, self.graphicsRotY)
        local maxDeltaRotY = math.rad(0.5) * dt
        self.graphicsRotY = math.min(math.max(self.targetGraphicsRotY, self.graphicsRotY - maxDeltaRotY), self.graphicsRotY + maxDeltaRotY)
        setRotation(self.skeletonRootNode, 0, self.graphicsRotY, 0)
	end;
end


Player.updateNetworkMovementHistory = function(self)
    if self.isEntered and self.isClient then
        self:raiseDirtyFlags(self.networkInformation.dirtyFlag)
    elseif thirdPerson.isActive and not self.isEntered and self.isControlled then--self.isServer and 
        local latestSimulatedIndex = -1
        while self.networkInformation.history[1] ~= nil and getIsPhysicsUpdateIndexSimulated(self.networkInformation.history[1].physicsIndex) do
            latestSimulatedIndex = self.networkInformation.history[1].index
            table.remove(self.networkInformation.history, 1)
        end
        if latestSimulatedIndex >= 0 then
            self.networkInformation.sendIndex = latestSimulatedIndex
            self:raiseDirtyFlags(self.networkInformation.dirtyFlag)
        end
    end
end

Player.onLeaveVehicle = function(self)
    self.playerStateMachine:deactivateState("animalRide");
    self.playerStateMachine:deactivateState("jump");
	if thirdPerson.camWasTP then
		setCamera(getChildAt(self.playerCamera2, 0));
		thirdPerson:setVisibility(self, true);
	else
		thirdPerson:resetFlashLight(self);
	end;
	thirdPerson.isActive = true;
end;

VehicleCharacter.loadCharacter = function(self, xmlFilename, playerStyle)
    local linkNode = Utils.getNoNil(self.characterNode, self.vehicle.rootNode);      
    Player.loadVisuals(self, xmlFilename, playerStyle, linkNode, false, self.ikChains, nil, nil, self.characterNode);
    local specIK = self.vehicle.spec_ikChains;
    if specIK ~= nil then
        for chainId, chain in pairs(self.ikChains) do
            specIK.chains[chainId] = chain;
        end;
        for ikChainId, target in pairs(self.ikChainTargets) do
            IKUtil.setTarget(self.ikChains, ikChainId, target);
        end;
    end;
    if self.characterSpineRotation ~= nil and self.thirdPersonSpineNode ~= nil then
        setRotation(self.thirdPersonSpineNode, unpack(self.characterSpineRotation));
    end;
    if self.useAnimation and self.skeletonThirdPerson ~= nil and getNumOfChildren(self.skeletonThirdPerson) > 0 then
        local animNode = g_animCache:getNode(AnimationCache.CHARACTER);
        cloneAnimCharacterSet(getChildAt(animNode, 0), self.skeletonThirdPerson);
        self.animationCharsetId = getAnimCharacterSet(getChildAt(self.skeletonThirdPerson, 0));
        self.animationPlayer = createConditionalAnimation();
        if self.animationCharsetId == 0 then
            g_logManager:devError("-- [VehicleCharacter:loadCharacter] Could not load animation CharSet from: [%s/%s]", getName(getParent(self.skeletonThirdPerson)), getName(self.skeletonThirdPerson));
            printScenegraph(getParent(self.skeletonThirdPerson));
        end;
    end;
    self:setCharacterDirty();
    self:setCharacterVisibility(true);
    self.isCharacterLoaded = true;
    return true;
end

Player.updateWaterParms = function(self, dt)
    local _, y, _ = getWorldTranslation(self.rootNode);
    local deltaWater = y - g_currentMission.waterY - self.baseInformation.capsuleTotalHeight * 0.5;
    local waterLevel = self.baseInformation.waterLevel;
    local velocityY = 0.0;
    if deltaWater < -50 then
        return;
    end;
    if not self.isEntered or thirdPerson.isActive then--
        velocityY = self.animationInformation.parameters.verticalVelocity.value;
    else
        velocityY = self.motionInformation.currentSpeedY;
    end;
    self.baseInformation.wasInWater = self.baseInformation.isInWater;
    self.baseInformation.isInWater = deltaWater <= waterLevel;
    if not self.baseInformation.wasInWater and self.baseInformation.isInWater and velocityY < self.baseInformation.plungedYVelocityThreshold then
        self.baseInformation.plungedInWater = true;
    else
        self.baseInformation.plungedInWater = false;
    end;
end;


Player.pickUpObject = function(self, state, noEventSend)
    PlayerPickUpObjectEvent.sendEvent(self, state, noEventSend)
    if self.isServer or thirdPerson.isActive then --
        if state and (self.isObjectInRange and self.lastFoundObject ~= nil) and not self.isCarryingObject then
            local constr = JointConstructor:new()
            self.pickedUpObjectCollisionMask = getCollisionMask(self.lastFoundObject)
            local newPickedUpObjectCollisionFlag = bitXOR(bitAND(self.pickedUpObjectCollisionMask, Player.movementCollisionMask), self.pickedUpObjectCollisionMask)
            setCollisionMask(self.lastFoundObject, newPickedUpObjectCollisionFlag)
            constr:setActors(self.pickUpKinematicHelperNode, self.lastFoundObject)
            for i=0, 2 do
                constr:setRotationLimit(i, 0, 0)
                constr:setTranslationLimit(i, true, 0, 0)
            end
            local mx, my, mz = getCenterOfMass(self.lastFoundObject)
            local wx, wy, wz = localToWorld(self.lastFoundObject, mx, my, mz)
            constr:setJointWorldPositions(wx, wy, wz, wx, wy, wz)
            local nx, ny, nz = localDirectionToWorld(self.lastFoundObject, 1, 0, 0)
            constr:setJointWorldAxes(nx, ny, nz, nx, ny, nz)
            local yx, yy, yz = localDirectionToWorld(self.lastFoundObject, 0, 1, 0)
            constr:setJointWorldNormals(yx, yy, yz, yx, yy, yz)
            constr:setEnableCollision(false)
            setWorldTranslation(self.pickUpKinematicHelperNodeChild, wx, wy, wz)
            setWorldRotation(self.pickUpKinematicHelperNodeChild, getWorldRotation(self.lastFoundObject))
            local dampingRatio = 1.0
            local mass = getMass(self.lastFoundObject)
            local rotationLimitSpring = {}
            local rotationLimitDamper = {}
            for i=1, 3 do
                rotationLimitSpring[i] = mass * 60
                rotationLimitDamper[i] = dampingRatio * 2 * math.sqrt( mass * rotationLimitSpring[i] )
            end
            constr:setRotationLimitSpring(rotationLimitSpring[1], rotationLimitDamper[1], rotationLimitSpring[2], rotationLimitDamper[2], rotationLimitSpring[3], rotationLimitDamper[3])
            local translationLimitSpring = {}
            local translationLimitDamper = {}
            for i=1, 3 do
                translationLimitSpring[i] = mass * 60
                translationLimitDamper[i] = dampingRatio * 2 * math.sqrt( mass * translationLimitSpring[i] )
            end
            constr:setTranslationLimitSpring(translationLimitSpring[1], translationLimitDamper[1], translationLimitSpring[2], translationLimitDamper[2], translationLimitSpring[3], translationLimitDamper[3])
            local forceAcceleration = 4
            local forceLimit = forceAcceleration * mass * 40.0
            constr:setBreakable(forceLimit, forceLimit)
            self.pickedUpObjectJointId = constr:finalize()
            addJointBreakReport(self.pickedUpObjectJointId, "onPickedUpObjectJointBreak", self)
            self.pickedUpObject = self.lastFoundObject
            self.isCarryingObject = true
            Player.PICKED_UP_OBJECTS[self.pickedUpObject] = true
            local object = g_currentMission:getNodeObject(self.pickedUpObject)
            if object ~= nil then
                object.thrownFromPosition = nil
            end
        else
            if self.pickedUpObjectJointId ~= nil then
                removeJoint(self.pickedUpObjectJointId)
                self.pickedUpObjectJointId = nil
                self.isCarryingObject = false
                Player.PICKED_UP_OBJECTS[self.pickedUpObject] = false
                if entityExists(self.pickedUpObject) then
                    local vx, vy, vz = getLinearVelocity(self.pickedUpObject)
                    vx = MathUtil.clamp(vx, -5, 5)
                    vy = MathUtil.clamp(vy, -5, 5)
                    vz = MathUtil.clamp(vz, -5, 5)
                    setLinearVelocity(self.pickedUpObject, vx, vy, vz)
                    setCollisionMask(self.pickedUpObject, self.pickedUpObjectCollisionMask)
                    self.pickedUpObjectCollisionMask = 0
                end
                local object = g_currentMission:getNodeObject(self.pickedUpObject)
                if object ~= nil then
                    object.thrownFromPosition = nil
                end
                self.pickedUpObject = nil
            end
        end
    end
end

--[[HandTool.load = function(self, xmlFilename, player)
    self.configFileName = xmlFilename;
    self.customEnvironment, self.baseDirectory = Utils.getModNameAndBaseDirectory(xmlFilename);
    local xmlFile = loadXMLFile("TempXML", xmlFilename);
    if xmlFile == 0 then
        return false;
    end;
    local i3dFilename = getXMLString(xmlFile, "handTool.filename");
    if i3dFilename == nil then
        delete(xmlFile);
        return false;
    end;
    self.i3dFilename = Utils.getFilename(i3dFilename, self.baseDirectory);
    local node = g_i3DManager:loadSharedI3DFile(self.i3dFilename);
    self.rootNode = getChildAt(node, 0);
    self.player = player;
    self.handNodePosition = {};
    self.handNodeRotation = {};
    self.handNode = nil;
    self.originalHandNodeParent = nil;
    self.referenceNode = nil;
    if not thirdPerson.isActive then
        self.handNodePosition = StringUtil.getVectorNFromString(Utils.getNoNil(getXMLString(xmlFile, "handTool.handNode.firstPerson#position"), "0 0 0"), 3);
        self.handNodeRotation = StringUtil.getRadiansFromString(Utils.getNoNil(getXMLString(xmlFile, "handTool.handNode.firstPerson#rotation"), "0 0 0"), 3);
        self.handNode = Utils.getNoNil(I3DUtil.indexToObject(self.rootNode, getXMLString(xmlFile, "handTool.handNode.firstPerson#node")), self.rootNode);
        self.referenceNode = I3DUtil.indexToObject(self.rootNode, getXMLString(xmlFile, "handTool.handNode.firstPerson#referenceNode"));
    else
        self.handNodePosition = StringUtil.getVectorNFromString(Utils.getNoNil(getXMLString(xmlFile, "handTool.handNode.thirdPerson#position"), "0 0 0"), 3);
        self.handNodeRotation = StringUtil.getRadiansFromString(Utils.getNoNil(getXMLString(xmlFile, "handTool.handNode.thirdPerson#rotation"), "0 0 0"), 3);
        self.handNode = Utils.getNoNil(I3DUtil.indexToObject(self.rootNode, getXMLString(xmlFile, "handTool.handNode.thirdPerson#node")), self.rootNode);
        self.referenceNode = I3DUtil.indexToObject(self.rootNode, getXMLString(xmlFile, "handTool.handNode.thirdPerson#referenceNode"));
    end;
    if self.rootNode ~= self.handNode then
        self.originalHandNodeParent = getParent(self.handNode);
    end;
    setTranslation(self.handNode, unpack(self.handNodePosition));
    setRotation(self.handNode, unpack(self.handNodeRotation));
    local storeItem = g_storeManager:getItemByXMLFilename(self.configFileName);
    if self.price == 0 or self.price == nil then
        self.price = StoreItemUtil.getDefaultPrice(storeItem);
    end;
    if g_currentMission ~= nil and storeItem.canBeSold then
        g_currentMission.environment:addDayChangeListener(self);
    end;
    self.targets = {};
    IKUtil.loadIKChainTargets(xmlFile, "handTool.targets", self.rootNode, self.targets, nil);
    setVisibility(self.rootNode, false);
    self.isActive = false;
    delete(xmlFile);
    return true;
end;]]

function Player:equipHandtool(handtoolFilename, force, noEventSend)
	force = force or thirdPerson.isActive;
    if self.isOwner then -- make sure we only change depth of field for locally controlled player instances
        if handtoolFilename == nil or handtoolFilename == "" then
            g_depthOfFieldManager:reset()
        else
            g_depthOfFieldManager:setManipulatedParams(0.8, 0.6, nil, nil, nil)
        end
    end
    PlayerSetHandToolEvent.sendEvent(self, handtoolFilename, force, noEventSend)
    if self:hasHandtoolEquipped() then
        if self.baseInformation.currentHandtool.configFileName:lower() ~= handtoolFilename:lower() or handtoolFilename == "" or force then
            self.baseInformation.currentHandtool:onDeactivate()
            self.baseInformation.currentHandtool:delete()
            self.baseInformation.currentHandtool = nil
        end
        if handtoolFilename ~= "" then
            self.baseInformation.currentHandtool = self:loadHandTool(handtoolFilename)
        end
    else
        if handtoolFilename ~= "" then
            self.baseInformation.currentHandtool = self:loadHandTool(handtoolFilename)
        end
    end
    -- if we have loaded a handtool, then we configure it
    if self:hasHandtoolEquipped() then
        self.baseInformation.currentHandtool:onActivate(self:getIsInputAllowed())
        self.baseInformation.currentHandtool:setHandNode(self.rightArmToolNode)
        local ikTargets = self.baseInformation.currentHandtool.targets
        if ikTargets ~= nil then
            for ikChainId, target in pairs(ikTargets) do
                IKUtil.setTarget(self.ikChains, ikChainId, target)
            end
            self:setIKDirty()
        end
    end
end